searchNodes=[{"doc":"This module contains functions and macros to be used with Pathex and i To use Pathex just insert to your context. You can import Pathex in module body or even in function body. require Pathex import Pathex , only : [ path : 1 , path : 2 , &quot;~&gt;&quot; : 2 , ... ] Or you can use use defmodule MyModule do # `default_mod` option is optional # when no mod is specified, `:naive` is selected use Pathex , default_mod : :json ... end This will import all operatiors and path macro Any macro here belongs to one of three categories: Macro which creates path closure (only path/2 ) Macro which uses path closure as path ( over/3 , set/3 , view/2 , ...) Macro which creates path composition ( ~&gt;/2 , |||/2 , ...)","ref":"Pathex.html","title":"Pathex","type":"module"},{"doc":"Creates composition of two paths which has some inspiration from logical and . This means that a &amp;&amp;&amp; b path-closure tries to apply a and only if it returns {:ok, something} , tries apply b and if b returns exactly the same as a does, the a &amp;&amp;&amp; b returns {:ok, something} Example: iex&gt; p1 = path :x / :y iex&gt; p2 = path :a / :b iex&gt; ap = p1 &amp;&amp;&amp; p2 iex&gt; { :ok , 1 } = view %{ x : %{ y : 1 } , a : [ b : 1 ] } , ap iex&gt; :error = view %{ x : %{ y : 1 } , a : [ b : 2 ] } , ap iex&gt; { :ok , %{ x : %{ y : 2 } , a : [ b : 2 ] } } = set %{ x : %{ y : 1 } , a : [ b : 1 ] } , ap , 2 iex&gt; { :ok , %{ x : %{ y : 2 } , a : %{ b : 2 } } } = force_set %{ } , ap , 2","ref":"Pathex.html#&&&/2","title":"Pathex.&&&/2","type":"macro"},{"doc":"Easy and convenient way to add pathex to your module. You can specify modifier use Pathex , default_mod : :json Or just use it with default :naive modifier use Pathex","ref":"Pathex.html#__using__/1","title":"Pathex.__using__/1","type":"macro"},{"doc":"This macro creates compositions of paths which work along with each other Think of alongside([path1, path2, path3]) as path1 &amp;&amp;&amp; path2 &amp;&amp;&amp; path3 The only difference is that for viewing alongside returns list of variables Example: iex&gt; pa = alongside [ path ( :x ) , path ( :y ) ] iex&gt; { :ok , [ 1 , 2 ] } = view ( %{ x : 1 , y : 2 } , pa ) iex&gt; { :ok , %{ x : 3 , y : 3 } } = set ( %{ x : 1 , y : 2 } , pa , 3 ) iex&gt; :error = set ( %{ x : 1 } , pa , 3 ) iex&gt; { :ok , %{ x : 1 , y : 1 } } = force_set ( %{ } , pa , 1 )","ref":"Pathex.html#alongside/1","title":"Pathex.alongside/1","type":"macro"},{"doc":"Applies func under path in struct and returns result of this func . Raises if path is not found. Example: iex&gt; x = 1 iex&gt; 9 = at! [ 0 , %{ x : 8 } ] , path ( x / :x ) , fn x -&gt; x + 1 end iex&gt; p = path &quot;hey&quot; / 0 iex&gt; { :here , 9 } = at! ( %{ &quot;hey&quot; =&gt; { 9 , - 9 } } , p , &amp; { :here , &amp;1 } )","ref":"Pathex.html#at!/3","title":"Pathex.at!/3","type":"macro"},{"doc":"Applies func under path in struct and returns result of this func . Example: iex&gt; x = 1 iex&gt; { :ok , 9 } = at [ 0 , %{ x : 8 } ] , path ( x / :x ) , fn x -&gt; x + 1 end iex&gt; p = path &quot;hey&quot; / 0 iex&gt; { :ok , { :here , 9 } } = at ( %{ &quot;hey&quot; =&gt; { 9 , - 9 } } , p , &amp; { :here , &amp;1 } )","ref":"Pathex.html#at/3","title":"Pathex.at/3","type":"macro"},{"doc":"The same as Pathex.~&gt;/2 for those who do not like operators Example: iex&gt; p1 = path :x / :y iex&gt; p2 = path :a / :b iex&gt; composed_path = concat ( p1 , p2 ) iex&gt; { :ok , 1 } = view %{ x : [ y : [ a : [ a : 0 , b : 1 ] ] ] } , composed_path","ref":"Pathex.html#concat/2","title":"Pathex.concat/2","type":"macro"},{"doc":"Deletes value under path in struct or raises if value is not found. Example: iex&gt; x = 1 iex&gt; [ 0 , %{ } ] = delete! ( [ 0 , %{ x : 8 } ] , path ( x / :x ) )","ref":"Pathex.html#delete!/2","title":"Pathex.delete!/2","type":"macro"},{"doc":"Deletes value under path in struct . Example: iex&gt; x = 1 iex&gt; { :ok , [ 0 , %{ } ] } = delete ( [ 0 , %{ x : 8 } ] , path ( x / :x ) ) iex&gt; :error = delete ( [ 0 , %{ x : 8 } ] , path ( 1 / :y ) )","ref":"Pathex.html#delete/2","title":"Pathex.delete/2","type":"macro"},{"doc":"Gets the value under path in struct or returns default value if not found. Example: iex&gt; x = 1 iex&gt; true = exists? ( [ 0 , %{ x : 8 } ] , path ( x / :x ) ) iex&gt; p = path &quot;hey&quot; / &quot;you&quot; iex&gt; false = exists? ( %{ &quot;hey&quot; =&gt; [ x : 1 ] } , p )","ref":"Pathex.html#exists?/2","title":"Pathex.exists?/2","type":"macro"},{"doc":"Applies func under path of struct . If the path does not exist it creates the path favouring maps when structure is unknown and inserts default value. Example: iex&gt; x = 1 iex&gt; [ 0 , %{ x : { :xxx , 8 } } ] = force_over! ( [ 0 , %{ x : 8 } ] , path ( x / :x ) , &amp; { :xxx , &amp;1 } , 123 ) iex&gt; p = path &quot;hey&quot; / 0 iex&gt; %{ &quot;hey&quot; =&gt; %{ 0 =&gt; 1 } } = force_over! ( %{ } , p , fn x -&gt; x + 1 end , 1 ) If the item in path doesn't have the right type, it raises. Example: iex&gt; p = path &quot;hey&quot; / &quot;you&quot; iex&gt; force_over! %{ &quot;hey&quot; =&gt; { 1 , 2 } } , p , fn x -&gt; x end , &quot;value&quot; ** (Pathex.Error) Type mismatch in structure","ref":"Pathex.html#force_over!/4","title":"Pathex.force_over!/4","type":"macro"},{"doc":"Applies func under path of struct . If the path does not exist it creates the path favouring maps when structure is unknown and inserts default value. Example: iex&gt; x = 1 iex&gt; { :ok , [ 0 , %{ x : { :xxx , 8 } } ] } = force_over ( [ 0 , %{ x : 8 } ] , path ( x / :x ) , &amp; { :xxx , &amp;1 } , 123 ) iex&gt; p = path &quot;hey&quot; / 0 iex&gt; { :ok , %{ &quot;hey&quot; =&gt; %{ 0 =&gt; 1 } } } = force_over ( %{ } , p , fn x -&gt; x + 1 end , 1 ) If the item in path doesn't have the right type, it returns :error . Example: iex&gt; p = path &quot;hey&quot; / &quot;you&quot; iex&gt; :error = force_over %{ &quot;hey&quot; =&gt; { 1 , 2 } } , p , fn x -&gt; x end , &quot;value&quot;","ref":"Pathex.html#force_over/4","title":"Pathex.force_over/4","type":"macro"},{"doc":"Sets the value under path in struct . If the path does not exist it creates the path favouring maps when structure is unknown. Example: iex&gt; x = 1 iex&gt; [ 0 , %{ x : 123 } ] = force_set! [ 0 , %{ x : 8 } ] , path ( x / :x ) , 123 iex&gt; p = path &quot;hey&quot; / 0 iex&gt; %{ &quot;hey&quot; =&gt; %{ 0 =&gt; 1 } } = force_set! %{ } , p , 1 If the item in path doesn't have the right type, it raises. Example: iex&gt; p = path &quot;hey&quot; / &quot;you&quot; iex&gt; force_set! %{ &quot;hey&quot; =&gt; { 1 , 2 } } , p , &quot;value&quot; ** (Pathex.Error) Type mismatch in structure Note that for paths created with Pathex.path/2 list and tuple indexes which are out of bounds fill the empty space with nil . Example: iex&gt; p = path 4 iex&gt; [ 1 , 2 , 3 , nil , 5 ] = force_set! [ 1 , 2 , 3 ] , p , 5 iex&gt; { 1 , 2 , 3 , nil , 5 } = force_set! { 1 , 2 , 3 } , p , 5 This is also true for negative indexes (except -1 for lists which always prepends) Example: iex&gt; p = path - 5 iex&gt; [ 0 , nil , 1 , 2 , 3 ] = force_set! [ 1 , 2 , 3 ] , p , 0 iex&gt; { 0 , nil , 1 , 2 , 3 } = force_set! { 1 , 2 , 3 } , p , 0","ref":"Pathex.html#force_set!/3","title":"Pathex.force_set!/3","type":"macro"},{"doc":"Sets the value under path in struct . If the path does not exist it creates the path favouring maps when structure is unknown. Example: iex&gt; x = 1 iex&gt; { :ok , [ 0 , %{ x : 123 } ] } = force_set [ 0 , %{ x : 8 } ] , path ( x / :x ) , 123 iex&gt; p = path &quot;hey&quot; / 0 iex&gt; { :ok , %{ &quot;hey&quot; =&gt; %{ 0 =&gt; 1 } } } = force_set %{ } , p , 1 If the item in path doesn't have the right type, it returns :error . Example: iex&gt; p = path &quot;hey&quot; / &quot;you&quot; iex&gt; :error = force_set %{ &quot;hey&quot; =&gt; { 1 , 2 } } , p , &quot;value&quot; Note that for paths created with Pathex.path/2 list and tuple indexes which are out of bounds fill the empty space with nil . Example: iex&gt; p = path 4 iex&gt; { :ok , [ 1 , 2 , 3 , nil , 5 ] } = force_set [ 1 , 2 , 3 ] , p , 5 iex&gt; { :ok , { 1 , 2 , 3 , nil , 5 } } = force_set { 1 , 2 , 3 } , p , 5 This is also true for negative indexes (except -1 for lists which always prepends) Example: iex&gt; p = path - 5 iex&gt; { :ok , [ 0 , nil , 1 , 2 , 3 ] } = force_set [ 1 , 2 , 3 ] , p , 0 iex&gt; { :ok , { 0 , nil , 1 , 2 , 3 } } = force_set { 1 , 2 , 3 } , p , 0","ref":"Pathex.html#force_set/3","title":"Pathex.force_set/3","type":"macro"},{"doc":"Gets the value under path in struct or returns default when path is not present. Example: iex&gt; x = 1 iex&gt; 8 = get ( [ 0 , %{ x : 8 } ] , path ( x / :x ) ) iex&gt; p = path &quot;hey&quot; / &quot;you&quot; iex&gt; nil = get ( %{ &quot;hey&quot; =&gt; [ x : 1 ] } , p ) iex&gt; :default = get ( %{ &quot;hey&quot; =&gt; [ x : 1 ] } , p , :default )","ref":"Pathex.html#get/3","title":"Pathex.get/3","type":"macro"},{"doc":"Inspect the given path-closure and returns string which corresponds to given path-closure Example: iex&gt; index = 1 iex&gt; p = path ( :x ) ~&gt; path ( :y / index ) &amp;&amp;&amp; path ( - 1 ) iex&gt; Pathex . inspect ( p ) &quot;path(:x) ~&gt; path(:y / 1) &amp;&amp;&amp; path(-1)&quot;","ref":"Pathex.html#inspect/1","title":"Pathex.inspect/1","type":"function"},{"doc":"Applies the func to the item under path in struct and returns modified structure. Works like Map.update!/3 . Example: iex&gt; x = 1 iex&gt; inc = fn x -&gt; x + 1 end iex&gt; [ 0 , %{ x : 9 } ] = over! [ 0 , %{ x : 8 } ] , path ( x / :x ) , inc iex&gt; p = path &quot;hey&quot; / 0 iex&gt; %{ &quot;hey&quot; =&gt; [ 2 , [ 2 ] ] } = over! %{ &quot;hey&quot; =&gt; [ 1 , [ 2 ] ] } , p , inc","ref":"Pathex.html#over!/3","title":"Pathex.over!/3","type":"macro"},{"doc":"Applies func to the item under the path in struct and returns modified structure. Works like Map.update!/3 but doesn't raise. Example: iex&gt; index = 1 iex&gt; inc = fn x -&gt; x + 1 end iex&gt; { :ok , [ 0 , %{ x : 9 } ] } = over [ 0 , %{ x : 8 } ] , path ( index / :x ) , inc iex&gt; p = path &quot;hey&quot; / 0 iex&gt; { :ok , %{ &quot;hey&quot; =&gt; [ 2 , [ 2 ] ] } } = over %{ &quot;hey&quot; =&gt; [ 1 , [ 2 ] ] } , p , inc Note: Exceptions from passed function left unhandled iex&gt; over ( %{ 1 =&gt; &quot;x&quot; } , path ( 1 ) , fn x -&gt; x + 1 end ) ** (ArithmeticError) bad argument in arithmetic expression","ref":"Pathex.html#over/3","title":"Pathex.over/3","type":"macro"},{"doc":"Creates path from quoted ast. Paths look like unix filesystems paths and consist of elements separated from each other with / . Each element defines the key or index in the collection. Example: iex&gt; x = 1 iex&gt; mypath = path 1 / :atom / &quot;string&quot; / { &quot;tuple?&quot; } / x iex&gt; structure = [ 0 , [ atom : %{ &quot;string&quot; =&gt; %{ { &quot;tuple?&quot; } =&gt; %{ 1 =&gt; 2 } } } ] ] iex&gt; { :ok , 2 } = view structure , mypath Paths can be used with one of the verbs in Pathex module (for example, Pathex.view/2 ). Paths can be customized with modifiers , composed using one of composition operators ( Pathex.concat/2 , Pathex.~&gt;/2 , Pathex.|||/2 , Pathex.&amp;&amp;&amp;/2 or Pathex.alongside/1 ). Note: Each element in path can have collection type annotated using :: operator. Available collection types are :list , :keyword , :tuple and :map . Multiple collections can be annotated using list It must comply with the limits set with modifier . Example: iex&gt; p = path ( ( 0 :: [ :list , :map ] ) / ( :x :: :keyword ) ) iex&gt; { :ok , :hit } = view %{ 0 =&gt; [ x : :hit ] } , p iex&gt; { :ok , :hit } = view [ [ x : :hit ] ] , p iex&gt; :error = view [ %{ x : :hit } ] , p","ref":"Pathex.html#path/2","title":"Pathex.path/2","type":"macro"},{"doc":"This macro converts path (which can be matched upon) into pattern. These requirements must be satisfied in order for this macro to work correctly: Path must be inlined into this macro. This means that path must be defined in a argument of this macro Defined paths must contain constants only Path must result only in case with one clause Example: iex&gt; import Pathex iex&gt; structure = %{ users : %{ 1 =&gt; %{ fname : &quot;Jose&quot; , lname : &quot;Valim&quot; } } } iex&gt; case structure do ...&gt; pattern ( fname , path ( :users / 1 / :fname , :map ) ) -&gt; ...&gt; { :ok , fname } ...&gt; ...&gt; _ -&gt; ...&gt; :error ...&gt; end { :ok , &quot;Jose&quot; }","ref":"Pathex.html#pattern/2","title":"Pathex.pattern/2","type":"macro"},{"doc":"Gets value under path in struct and then deletes it. Note: Current implementation of this function performs double lookup. Which is still more efficient than pop_in Example: iex&gt; { 1 , [ 2 , 3 ] } = pop! ( [ 1 , 2 , 3 ] , path ( 0 ) )","ref":"Pathex.html#pop!/2","title":"Pathex.pop!/2","type":"macro"},{"doc":"Macro which gets value in the structure and deletes it. Note: Current implementation of this function performs double lookup. Which is still more efficient than pop_in Example: iex&gt; { :ok , { 1 , [ 2 , 3 ] } } = pop ( [ 1 , 2 , 3 ] , path ( 0 ) )","ref":"Pathex.html#pop/2","title":"Pathex.pop/2","type":"macro"},{"doc":"Sets the value under path in struct . Think of it like Map.put/3 . Example: iex&gt; x = 1 iex&gt; [ 0 , %{ x : 123 } ] = set! [ 0 , %{ x : 8 } ] , path ( x / :x ) , 123 iex&gt; p = path &quot;hey&quot; / 0 iex&gt; %{ &quot;hey&quot; =&gt; [ 123 , [ 2 ] ] } = set! %{ &quot;hey&quot; =&gt; [ 1 , [ 2 ] ] } , p , 123","ref":"Pathex.html#set!/3","title":"Pathex.set!/3","type":"macro"},{"doc":"Sets value under path in structure . Think of it like Map.put/3 . Example: iex&gt; x = 1 iex&gt; { :ok , [ 0 , %{ x : 123 } ] } = set [ 0 , %{ x : 8 } ] , path ( x / :x ) , 123 iex&gt; p = path &quot;hey&quot; / 0 iex&gt; { :ok , %{ &quot;hey&quot; =&gt; [ 123 , [ 2 ] ] } } = set %{ &quot;hey&quot; =&gt; [ 1 , [ 2 ] ] } , p , 123","ref":"Pathex.html#set/3","title":"Pathex.set/3","type":"macro"},{"doc":"Gets the value under path in struct . Raises if path not found. Example: iex&gt; x = 1 iex&gt; 8 = view! [ 0 , %{ x : 8 } ] , path ( x / :x ) iex&gt; p = path &quot;hey&quot; / 0 iex&gt; 9 = view! %{ &quot;hey&quot; =&gt; { 9 , - 9 } } , p","ref":"Pathex.html#view!/2","title":"Pathex.view!/2","type":"macro"},{"doc":"Gets the value under path in struct . Example: iex&gt; x = 1 iex&gt; { :ok , 8 } = view [ 0 , %{ x : 8 } ] , path ( x / :x ) iex&gt; p = path &quot;hey&quot; / 0 iex&gt; { :ok , 9 } = view %{ &quot;hey&quot; =&gt; { 9 , - 9 } } , p","ref":"Pathex.html#view/2","title":"Pathex.view/2","type":"macro"},{"doc":"Creates composition of two paths which has some inspiration from logical or . This means that a ||| b path-closure tries to apply a and only if it returns :error , tries apply b Example: iex&gt; p1 = path :x / :y iex&gt; p2 = path :a / :b iex&gt; op = p1 ||| p2 iex&gt; { :ok , 1 } = view %{ x : %{ y : 1 } , a : [ b : 2 ] } , op iex&gt; { :ok , 2 } = view %{ x : 1 , a : [ b : 2 ] } , op iex&gt; { :ok , %{ x : %{ y : 2 } , a : [ b : 1 ] } } = set %{ x : %{ y : 1 } , a : [ b : 1 ] } , op , 2 iex&gt; { :ok , %{ x : %{ y : 2 } } } = force_set %{ } , op , 2 iex&gt; { :ok , %{ x : %{ } , a : [ b : 1 ] } } = force_set %{ x : %{ y : 1 } , a : [ b : 1 ] } , op , 2","ref":"Pathex.html#%7C%7C%7C/2","title":"Pathex.|||/2","type":"macro"},{"doc":"Creates composition of two paths similar to concatenating them together. This means that a ~&gt; b path-closure applies a and only if it returns {:ok, something} it applies b to something Example: iex&gt; p1 = path :x / :y iex&gt; p2 = path :a / :b iex&gt; composed_path = p1 ~&gt; p2 iex&gt; { :ok , 1 } = view %{ x : [ y : [ a : [ a : 0 , b : 1 ] ] ] } , composed_path","ref":"Pathex.html#~%3E/2","title":"Pathex.~>/2","type":"macro"},{"doc":"","ref":"Pathex.html#t:force_update_args/2","title":"Pathex.force_update_args/2","type":"type"},{"doc":"Function which is passed to path-closure as second element in args tuple","ref":"Pathex.html#t:inner_func/1","title":"Pathex.inner_func/1","type":"type"},{"doc":"","ref":"Pathex.html#t:inspect_args/0","title":"Pathex.inspect_args/0","type":"type"},{"doc":"More about modifiers","ref":"Pathex.html#t:mod/0","title":"Pathex.mod/0","type":"type"},{"doc":"This depends on the modifier","ref":"Pathex.html#t:pathex_compatible_structure/0","title":"Pathex.pathex_compatible_structure/0","type":"type"},{"doc":"Value returned by non-bang path call","ref":"Pathex.html#t:result/1","title":"Pathex.result/1","type":"type"},{"doc":"Also known as path-closure","ref":"Pathex.html#t:t/0","title":"Pathex.t/0","type":"type"},{"doc":"Also known as path-closure","ref":"Pathex.html#t:t/2","title":"Pathex.t/2","type":"type"},{"doc":"","ref":"Pathex.html#t:update_args/2","title":"Pathex.update_args/2","type":"type"},{"doc":"Helpers to create paths from Access.t() and lists Note: This module is separate because functions presented in this module are suboptimal. You should try use Pathex.path/2 first, and only if its not applicable to you use-case, you should use functions from this module","ref":"Pathex.Accessibility.html","title":"Pathex.Accessibility","type":"module"},{"doc":"Creates path-closure from Access.t() . Note: Paths created using this function do not support force operations yet Example: iex&gt; import Pathex iex&gt; p = from_access [ :x , :y ] iex&gt; 10 = view! ( %{ x : [ y : 10 ] } , p )","ref":"Pathex.Accessibility.html#from_access/1","title":"Pathex.Accessibility.from_access/1","type":"function"},{"doc":"Creates path from list of items. The list of items should not be known at runtime, therefore some optimizations of paths are not possible. Use this function only when Pathex.path/2 is not applicable Example: iex&gt; import Pathex iex&gt; p = from_list [ :x , 1 , :y ] iex&gt; 10 = view! ( %{ x : [ 1 , [ y : 10 ] ] } , p )","ref":"Pathex.Accessibility.html#from_list/2","title":"Pathex.Accessibility.from_list/2","type":"function"},{"doc":"Converts path-closure to Access.t() Example: iex&gt; import Pathex iex&gt; access = to_access path ( :x / 0 , :map ) iex&gt; 1 = get_in ( %{ x : %{ 0 =&gt; 1 } } , access )","ref":"Pathex.Accessibility.html#to_access/1","title":"Pathex.Accessibility.to_access/1","type":"function"},{"doc":"","ref":"Pathex.Accessibility.html#t:access/0","title":"Pathex.Accessibility.access/0","type":"type"},{"doc":"Combinator for lenses Read Pathex.Combinator.combine/1 documentation","ref":"Pathex.Combinator.html","title":"Pathex.Combinator","type":"module"},{"doc":"This function creates a recursive path from path defined in path_func Consider this example iex&gt; import Pathex ; import Pathex.Lenses iex&gt; recursive_xpath = combine ( fn recursive_xpath -&gt; iex&gt; path ( :x ) # Takes by :x key iex&gt; ~&gt; recursive_xpath # If taken, calls itself iex&gt; ||| matching ( _ ) # Otherwise returns current structure iex&gt; end ) iex&gt; iex&gt; Pathex . view! ( %{ x : %{ x : %{ x : %{ x : 1 } } } } , recursive_xpath ) 1 iex&gt; Pathex . set! ( %{ x : %{ x : %{ x : %{ x : 1 } } } } , recursive_xpath , 2 ) %{ x : %{ x : %{ x : %{ x : 2 } } } } The second argument of this function specifies the maximum depth. It's infinity be default, but you can specify this as any positive integer. It is useful when you're developing lens and you're not sure whether the lens will or won't loop. For example # Combinator lens with limit limited = combine ( fn rec -&gt; path ( :x ) ~&gt; rec end , 100_000 ) :error = Pathex . force_set ( %{ x : 1 } , limited , 123 ) # And this is without limit unlimited = combine ( fn rec -&gt; path ( :x ) ~&gt; rec end ) Pathex . force_set ( %{ x : 1 } , unlimited , 123 ) # Infinite loop","ref":"Pathex.Combinator.html#combine/2","title":"Pathex.Combinator.combine/2","type":"function"},{"doc":"Special lens which logs all operation and performs the same way matching(_) does","ref":"Pathex.Debug.html","title":"Pathex.Debug","type":"module"},{"doc":"","ref":"Pathex.Debug.html#debug/1","title":"Pathex.Debug.debug/1","type":"function"},{"doc":"Module with collection of prebuilt paths","ref":"Pathex.Lenses.html","title":"Pathex.Lenses","type":"module"},{"doc":"Path function which works with all possible keys it can find It takes all keys and than applies inner function (or concated path) If any application fails, this lens returns :error Example: iex&gt; require Pathex ; import Pathex iex&gt; alll = Pathex.Lenses . all ( ) iex&gt; Pathex . over! ( [ %{ x : 0 } , [ x : 1 ] ] , alll ~&gt; path ( :x ) , fn x -&gt; x + 1 end ) [ %{ x : 1 } , [ x : 2 ] ] iex&gt; Pathex . view! ( %{ x : 1 , y : 2 , z : 3 } , alll ) |&gt; Enum . sort ( ) [ 1 , 2 , 3 ] iex&gt; Pathex . set ( [ x : 1 , y : 0 ] , alll , 2 ) { :ok , [ x : 2 , y : 2 ] }","ref":"Pathex.Lenses.html#all/0","title":"Pathex.Lenses.all/0","type":"function"},{"doc":"Path function which works with any possible key it can find It takes any key and than applies inner function (or concated path) Example: iex&gt; require Pathex iex&gt; anyl = Pathex.Lenses . any ( ) iex&gt; { :ok , 1 } = Pathex . view %{ x : 1 } , anyl iex&gt; { :ok , [ 9 ] } = Pathex . set [ 8 ] , anyl , 9 iex&gt; { :ok , [ x : 1 , y : 2 ] } = Pathex . force_set [ x : 0 , y : 2 ] , anyl , 1 Note that force setting value to empty map has undefined behaviour and therefore returns an error: iex&gt; require Pathex iex&gt; anyl = Pathex.Lenses . any ( ) iex&gt; :error = Pathex . force_set ( %{ } , anyl , :well ) And note that this lens has keywords at head of list at a higher priority than non-keyword heads: iex&gt; require Pathex iex&gt; anyl = Pathex.Lenses . any ( ) iex&gt; { :ok , [ { :x , 1 } , 2 ] } = Pathex . set ( [ { :x , 0 } , 2 ] , anyl , 1 ) iex&gt; { :ok , [ 1 , { :x , 2 } ] } = Pathex . set ( [ 0 , { :x , 2 } ] , anyl , 1 ) iex&gt; { :ok , [ 1 , 2 ] } = Pathex . set ( [ { &quot;some_tuple&quot; , &quot;here&quot; } , 2 ] , anyl , 1 )","ref":"Pathex.Lenses.html#any/0","title":"Pathex.Lenses.any/0","type":"function"},{"doc":"This macro creates path-closure successes only when predicate returns truthy value. predicate is a function which takes a structures upon which the path is called and returns a boolean (or any other type which will be treated as boolean). This function is useful when composed with star/0 and some/0 Note: In terms of functional programming, such conditional lenses are called prisms Example: iex&gt; import Pathex.Lenses ; import Pathex iex&gt; adminl = filtering ( &amp; &amp;1 . role == :admin ) iex&gt; { :ok , %{ name : &quot;Name&quot; , role : :admin } } = Pathex . view ( %{ name : &quot;Name&quot; , role : :admin } , adminl ) iex&gt; :error = Pathex . view ( %{ role : :user } , adminl ) iex&gt; import Pathex.Lenses ; import Pathex iex&gt; dots2d = [ { 1 , 1 } , { 1 , 5 } , { 3 , 0 } , { 4 , 3 } ] iex&gt; higher_than_2 = filtering ( fn { _x , y } -&gt; y &gt; 2 end ) iex&gt; { :ok , [ { 1 , 5 } , { 4 , 3 } ] } = Pathex . view ( dots2d , star ( ) ~&gt; higher_than_2 )","ref":"Pathex.Lenses.html#filtering/1","title":"Pathex.Lenses.filtering/1","type":"function"},{"doc":"This macro creates path-closure which successes only when input matches the pattern . The pattern can be just a pattern or a pattern with when . You can write this patterns just like you'd write them in case This function is useful when composed with star/0 and some/0 Note: In terms of functional programming, such conditional lenses are called prisms Example: iex&gt; import Pathex.Lenses ; import Pathex iex&gt; adminl = matching ( %{ role : :admin } ) iex&gt; { :ok , %{ name : &quot;Name&quot; , role : :admin } } = Pathex . view ( %{ name : &quot;Name&quot; , role : :admin } , adminl ) iex&gt; :error = Pathex . view ( %{ } , adminl ) iex&gt; import Pathex.Lenses ; import Pathex iex&gt; dots2d = [ { 1 , 1 } , { 1 , 5 } , { 3 , 0 } , { 4 , 3 } ] iex&gt; higher_than_2 = matching ( { _x , y } when y &gt; 2 ) iex&gt; { :ok , [ { 1 , 5 } , { 4 , 3 } ] } = Pathex . view ( dots2d , star ( ) ~&gt; higher_than_2 )","ref":"Pathex.Lenses.html#matching/1","title":"Pathex.Lenses.matching/1","type":"macro"},{"doc":"Path function which applies inner function (or concated path-closure) to the first value it can apply it to Example: iex&gt; require Pathex ; import Pathex iex&gt; somel = Pathex.Lenses . some ( ) iex&gt; Pathex . view! ( [ x : [ 11 ] , y : [ 22 ] , z : 33 ] , somel ~&gt; path ( 0 ) ) 11 iex&gt; Pathex . set! ( [ x : %{ y : 0 } , z : %{ y : 0 } ] , somel ~&gt; path ( :y , :map ) , 1 ) [ x : %{ y : 1 } , z : %{ y : 0 } ] iex&gt; Pathex . view ( [ x : 1 , y : 2 , z : 3 ] , somel ) { :ok , 1 } Note: Force update fails for empty structures Think of this function as star() ~&gt; any() but optimized to work with only first element","ref":"Pathex.Lenses.html#some/0","title":"Pathex.Lenses.some/0","type":"function"},{"doc":"Path function which applies inner function (or concated path-closure) to every value it can apply it to Example: iex&gt; require Pathex ; import Pathex iex&gt; starl = Pathex.Lenses . star ( ) iex&gt; Pathex . view! ( %{ x : [ 1 ] , y : [ 2 ] , z : 3 } , starl ~&gt; path ( 0 ) ) |&gt; Enum . sort ( ) [ 1 , 2 ] iex&gt; Pathex . set! ( %{ x : %{ y : 0 } , z : [ 3 ] } , starl ~&gt; path ( :y , :map ) , 1 ) %{ x : %{ y : 1 } , z : [ 3 ] } iex&gt; Pathex . view ( [ x : 1 , y : 2 , z : 3 ] , starl ) { :ok , [ 1 , 2 , 3 ] } Note: It returns :error when no data was found or changed Think of this function as filter_map . It is particularly useful for filtering and selecting needed values with custom functions or matching/1 macro Example: iex&gt; require Pathex ; import Pathex ; require Pathex.Lenses iex&gt; starl = Pathex.Lenses . star ( ) iex&gt; structure = [ { 1 , 4 } , { 2 , 8 } , { 3 , 6 } , { 4 , 10 } ] iex&gt; # iex&gt; # For example we want to select all tuples with first element greater than 2 iex&gt; # iex&gt; greater_than_2 = Pathex.Lenses . matching ( { x , _ } when x &gt; 2 ) iex&gt; Pathex . view ( structure , starl ~&gt; greater_than_2 ) { :ok , [ { 3 , 6 } , { 4 , 10 } ] }","ref":"Pathex.Lenses.html#star/0","title":"Pathex.Lenses.star/0","type":"function"},{"doc":"This module provides short definitions of pathex paths. For example, when using Pathex.Short , you can transform this path :x / :y / 1 / 2 To just this :x / :y / 1 / 2","ref":"Pathex.Short.html","title":"Pathex.Short","type":"module"},{"doc":"This macro redefines / operator, so use this macro with caution or only in bounded context (for example, you can use Pathex.Short only inside functions) Example: iex&gt; use Pathex.Short iex&gt; path = :x / :y iex&gt; 1 = Pathex . view! ( %{ x : %{ y : 1 } } , path )","ref":"Pathex.Short.html#//2","title":"Pathex.Short.//2","type":"macro"},{"doc":"Simple exception for bang! functions (like Pathex.view!/2 ) errors. Note: Some new field may be added in the future","ref":"Pathex.Error.html","title":"Pathex.Error","type":"exception"},{"doc":"","ref":"Pathex.Error.html#t:t/0","title":"Pathex.Error.t/0","type":"type"},{"doc":"Speed or composability? Choose both! What is Pathex? Pathex is a library for performing fast actions with nested data structures in Elixir. With pathex you can trivially set, get and update values in structures in a functional manner. It provides all necessary logic to manipulate data structures in different ways using flexible functional lens pattern. Why another library? Existing methods of accesssing data in nested structures are either slow (like Focus ) or do not provide enough functionality (like Access ). For example setting the value in structure with Pathex is 70-160x faster than Focus or 2-3x faster than put_in and get_in You can checkout benchmarks at https://github.com/hissssst/pathex_bench","ref":"readme.html","title":"Pathex","type":"extras"},{"doc":"Pathex is really simple and straightforward to use (almost like Enum ). You don't need to learn any specific language, just create paths with path and use verbs with them. Add it to your module # This will import path macro and operators and require Pathex use Pathex Or just import Pathex Create the path path_to_streets = path :user / :private / :addresses / 0 / :street path_in_json = path &quot;users&quot; / 1 / &quot;street&quot; , :json This creates closure which can get, set, update and delete values in this path Use the path { :ok , &quot;6th avenue&quot; = street } = %{ user : %{ id : 1 , name : &quot;hissssst&quot; , private : %{ phone : &quot;123-456-789&quot; , addresses : [ [ city : &quot;City&quot; , street : &quot;6th avenue&quot; , mail_index : 123456 ] ] } } } |&gt; Pathex . view ( path_to_streets ) %{ &quot;users&quot; =&gt; %{ 1 =&gt; %{ &quot;street&quot; =&gt; &quot;6th avenue&quot; } } } = Pathex . force_set! ( %{ } , path_in_json , street )","ref":"readme.html#usage","title":"Pathex - Usage","type":"extras"},{"doc":"Pathex has a lot of different features and can even compete with code written by hand in terms of efficiency. Pathex significantly reduces the time to write a code which manipulates nested structure, while providing efficiency and composability. No more functions like get_users , set_users , update_users ! No more XPaths, JSONPaths, CSS Selectors! Easy to use It's not harder to use than Map or Enum ! Check out the cheatsheet for common tasks. Pathex also provides more information about errors than any other tool. iex(1)&gt; field = :email iex(2)&gt; Pathex . view! ( %{ } , path ( :users ) ~&gt; all ( ) ~&gt; path ( :personal / field ) ) ** (Pathex.Error) Couldn &#39; t find element Path : path ( :users ) ~&gt; all ( ) ~&gt; path ( :personal / :email ) Structure : %{ } Fast Paths are just a set of pattern-matching cases. This is done to extract maximum efficiency from BEAM's pattern-matching compiler. # Code for viewing variables for path path ( 1 / &quot;y&quot; , :map ) # Almost equals to case input do %{ 1 =&gt; %{ &quot;y&quot; =&gt; res } } -&gt; { :ok , res } _ -&gt; :error end Reusable One path can be used to update, get, set, delete a value in the structure! And paths can be composed together. This composition is very efficient, there's no need to concat lists like Access does. # User structure user = % User { personal : %{ fname : &quot;Kabs&quot; , sname : &quot;Rocks&quot; } , phone : &quot;123-456-789&quot; } # Path to username in user structure username = path ( :personal / :fname ) # Get a username { :ok , &quot;Kabs&quot; } = Pathex . view ( user , username ) # Set a username another_user = % User { personal : %{ fname : &quot;Blabs&quot; , sname : &quot;Rocks&quot; } , phone : &quot;123-456-789&quot; } = Pathex . set! ( user , username , &quot;Blabs&quot; ) # Get all usernames! import Pathex.Lenses [ &quot;Kabs&quot; , &quot;Blabs&quot; ] = [ user , another_user ] |&gt; Pathex . view! ( all ( ) ~&gt; username ) Pathex can be used to manipulate different nested data structure. From GenServer state to HTML or Elixir's AST! Extensible Pathex is built around simple primitive called path-closure , which is a simple closure with clearly defined specification. Anything complying with Pathex.t() spec can be used within Pathex .","ref":"readme.html#features","title":"Pathex - Features","type":"extras"},{"doc":"def deps do [ { :pathex , &quot;~&gt; 2.0&quot; } ] end","ref":"readme.html#installation","title":"Pathex - Installation","type":"extras"},{"doc":"Welcome! If you want to get your hands dirty, you can check existing TODO 's. By the way If you have any suggestions or want to change something in this library don't hesitate to open an issue. If you have any whitepapers about functional lenses, you can add them in a PR to the bottom of this readme","ref":"readme.html#contributions","title":"Pathex - Contributions","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Negative indexes, lens fixes, force_update nil filling and refactoring Breaking matching force_update fix. Now it doesn't raise an error when called filtering force_update fix. Now it doesn't raise an error when called Tuple force_update fix. Now it works with indexes and for force_set {}, path(2), 1 it will create {nil, nil, 1} . List force_update fix. Now it works with indexes and for force_set [], path(2), 1 it will create [nil, nil, 1] . Non-breaking Tuple negative index is now supported for all operations List negative indexes now work the same way as positive indexes (but backwards), except -1 which still prepends to the list.","ref":"changelog.html#2-4","title":"Changelog - 2.4","type":"extras"},{"doc":"Breaking Pathex now uses Elixir 1.13 (or higher) version Non-breaking Pathex.t spec fix Pathex.Short for shorter path definition Pathex.pattern for creating patterns from inlined paths Pathex now can be use -d inside functions or anything like this Paths inlining is now detected for aliased, imported and macro calls Internal spec fixes, dead code eliminations and formatting","ref":"changelog.html#2-3","title":"Changelog - 2.3","type":"extras"},{"doc":"Breaking Changed behaviour of path-closures created with path when working with improper Keyword.t() Non-breaking Improved documentation Removed dead code Added Pathex.Accessibility module for creating paths in runtime","ref":"changelog.html#2-2","title":"Changelog - 2.2","type":"extras"},{"doc":"Breaking Updating and viewing keywords with star and some lenses now doesn't raise when they're used against non-proper keyword Non-breaking Concatenated paths now can force_over for not only maps Fixed debug lens Added ability to pass calls and arbitary structures into path macro Unrolled some clauses for star and some for extra efficiency","ref":"changelog.html#2-1","title":"Changelog - 2.1","type":"extras"},{"doc":"Breaking Reworked star lens. Now it is less optimistic and returns :error when no values were viewed/updated Removed sigils Removed deprecated lens id Removed deprecated lens either Removed recur function Non-breaking compose function for recursive lens delete method for all paths, lenses and higher order functions inspect method for all paths, lenses and higher order functions Matchable updater for lists and maps Builders are selected for combination (not for mod as they used to) Reworked documentation Annotated paths","ref":"changelog.html#2-0","title":"Changelog - 2.0","type":"extras"},{"doc":"Breaking None! (See deprecated in Non-breaking) Non-breaking Deprecated id lens Deprecated either lens Fixed bug with concatenation context overlapping some lens star lens matching lens filtering lens Removed some dead code Moved lenses code to separate modules","ref":"changelog.html#1-3-0","title":"Changelog - 1.3.0","type":"extras"},{"doc":"Breaking None! Non-breaking star lens all lens","ref":"changelog.html#1-2-0","title":"Changelog - 1.2.0","type":"extras"},{"doc":"Breaking None! Non-breaking ||| operator stack-optimized version of ~&gt; operator stack-optimized version of ||| operator","ref":"changelog.html#1-1-0","title":"Changelog - 1.1.0","type":"extras"},{"doc":"Breaking force_set / get / set clause in closure was renamed to force_update / view / update and added a special argument with default value in it Non-breaking alongside macro stack-optimized version of &amp;&amp;&amp; operator path code generation size assertion better documentation format id lens either lens any lens Yeah, it starts from 1.0.0 I can describe previous versions if anybody needs this. Just open an issue! :)","ref":"changelog.html#1-0-0","title":"Changelog - 1.0.0","type":"extras"},{"doc":"This guide will show the basics of Pathex . This is the best place to start learning Pathex . It won't take more than 5 minutes. As README says, Pathex is a library for working with collections and nested key-value structures. Pathex uses powerful functional abstraction called lens (in Pathex we call it path or path-closure, you'll later see why). Path is a basically a path to value in nested structure, almost like filesystem path.","ref":"basics.html","title":"Basics","type":"extras"},{"doc":"First of all, we need to know how to create paths. Path can be created with Pathex.path/2 macro. For example: p = path :x / :y # Note the &quot;/&quot;. That&#39;s why the library is called Pathex This path specifies a way to get (or set, or delete or whatever) value 1 from %{x: %{y: 1}} Note: You don't have to capture used variables x = 1 path :some_atom / x # Right path :some_atom / ^ x # Wrong Each type of value used in path corresponds to one or more types of Elixir collections Strings, tuples, maps, functions, lists are treated only as Map keys. Atoms are treated as Map or Keyword keys. Positive integers are treated as Map keys or List and Tuple indexes Negative integers are treated as Map keys or first element in List 's view or prepending element in List 's update or force_set operations Variables are treated the same way as the type they have in runtime. For example, variables containing negative integers are treated as negative integer values. Unfortunately, it is not possible to know variable type at compile-time, that's why Pathex generates code for all possible types. See performance tips for more information.","ref":"basics.html#create-paths","title":"Basics - Create paths","type":"extras"},{"doc":"Alright, we have a path. Now, we need to know how to use it Let's take a value from nested structure iex&gt; p = path :usernames / 0 iex&gt; Pathex . view ( %{ usernames : [ &quot;SubZero&quot; , &quot;Scorpion&quot; ] } , p ) { :ok , &quot;SubZero&quot; } There are a lot of other ways to use paths. Every macro with human-readable name (except path ) is a macro for using path in some way, check Pathex documentation. In all such macros first argument is an input structure and the second argument is a path-closure itself Note: Path-closure which are created inside path-using macro are optimised to have only one operation generated (instead of default three). You can read more about path-closures and operations here As usual Macro without ! always return {:ok, result} or :error Macro with ! return result or raise Pathex.Error","ref":"basics.html#use-paths","title":"Basics - Use paths","type":"extras"},{"doc":"Path-closures can be composed together to create new path-closure, every path comosition macro is a binary operator. Some compositions are optimized to have generate one closure even if multiple closures are used. You can concat paths with Pathex.~&gt;/2 composition macro iex&gt; p1 = path :x iex&gt; p2 = path :y iex&gt; composed_path = p1 ~&gt; p2 iex&gt; 1 = Pathex . view ( %{ x : [ y : 1 ] } , composed_path ) Think about paths composition just like paths concatenation in shell For example iex&gt; first_user = path :users / 0 # users/0 iex&gt; name = path :name # name iex&gt; first_user_name = first_user ~&gt; name # users/0/name","ref":"basics.html#compose-paths","title":"Basics - Compose paths","type":"extras"},{"doc":"Pathex provides some prebuilt paths for non-standart data manipulation. You can find them in Pathex.Lenses module. You can read more about them in lenses guide For example Pathex.Lenses.star/0 lens works just like * in filesystem path.","ref":"basics.html#prebuilt-paths","title":"Basics - Prebuilt paths","type":"extras"},{"doc":"General rule: the more data you provide to Pathex at compile-time the better For example: path ( 1 / :x / :y , :json ) # works faster than path ( 1 / :x / :y ) Because :json mod optimizes closure to one big case, while default :naive mod generates nested cases And, in this example: path ( 1 / :x / :y ) # works faster than x = :x ; path ( 1 / x / :y ) Because constants provide more information about available type. This means that for :x pathex know that this can be a to Keyword or Map , while x means that this is a variable which can contain List / Tuple index or Map / Keyword value And, in this example: path ( 1 / x / :y ) # works faster than path ( 1 ) ~&gt; path ( x ) ~&gt; path ( :y ) Because paths concatenation actually creates a path which calls all operands internally which increases the call stack and makes concatenated path handle errors by hand","ref":"basics.html#performance-tips","title":"Basics - Performance tips","type":"extras"},{"doc":"This documentation page is intended to provide some common use cases of Pathex .","ref":"cheatsheet.html","title":"Cheatsheet","type":"extras"},{"doc":"This section describes actions which can be used with path-closures. Note that for single-key operations Pathex is slightly slower than Map or Keyword Map Pathex Map.fetch/2 Pathex.view/2 Map.get/3 Pathex.get/3 Map.update!/3 Pathex.over/3 Map.update/4 Pathex.force_over/4 Map.put/3 Pathex.force_set/3 Map.replace/3 Pathex.set/3 Map.delete/2 Pathex.delete/2","ref":"cheatsheet.html#operations","title":"Cheatsheet - Operations","type":"extras"},{"doc":"This section describes how Pathex can be used instead of Access for accessing nested data structures. Note that Pathex is 2 to 4 times faster than Access Access Pathex get_in(s, [:x, :y, :z]) Pathex.get(s, path(:x / :y / :z)) put_in(s, [:x, :y, :z], v) Pathex.set(s, path(:x / :y / :z), v) Note that Pathex works with structures (i.e. %User{} ) like maps and doesn't need any special behaviour implemented in the module. Plus Pathex also works with tuples and lists This means that this code structure |&gt; get_in ( [ :x , :y , :z ] ) |&gt; Enum . at ( 10 ) |&gt; elem ( 1 ) |&gt; get_in ( [ :z , :y , :x ] ) Can be rewritten to Pathex . view ( structure , path ( :x / :y / :z / 10 / 1 / :z / :y / :x ) )","ref":"cheatsheet.html#nested","title":"Cheatsheet - Nested","type":"extras"},{"doc":"Enum Pathex Enum.find/2 Pathex.Lenses.some/0 Enum.map/2 Pathex.Lenses.all/0 Enum.filter_map/3 Pathex.Lenses.star/0 Enum.at/2 path() More examples in Lenses tutorial","ref":"cheatsheet.html#enumerables-and-lenses","title":"Cheatsheet - Enumerables and lenses","type":"extras"},{"doc":"This function traverses all leaves in the structure use Pathex ; import Pathex.Combinator ; import Pathex.Lenses def leaves ( iterlens \\\\ star ( ) ) do combine ( fn recursive -&gt; iterlens ~&gt; ( recursive ||| matching ( _ ) ) end ) end [ 2 , 1 , [ :dot , 1234 ] ] = %{ x : 1 , y : 2 , meta : %{ type : :dot , id : 1234 } } |&gt; Pathex . view! ( leaves ) You can change the star() lens to whatever lens you prefer. For example, for parsed HTML documents you can use star() ~&gt; path(2) to not traverse attributes. And if you want to find one leaf, you can use some()","ref":"cheatsheet.html#traverse-leaves","title":"Cheatsheet - Traverse leaves","type":"extras"},{"doc":"If you want to walk the whole structure, not only leaves, but the structure and it's substructures too, you can use this function use Pathex ; import Pathex.Combinator ; import Pathex.Lenses # Like Macro.postwalk but for any tree-like structure def postwalking ( iterlens , predicate ) do combine ( fn recursive -&gt; predicate ~&gt; ( alongside ( [ iterlens ~&gt; recursive , matching ( _ ) ] ) ||| matching ( _ ) ) ||| ( iterlens ~&gt; recursive ) end ) end # Like Macro.prewalk but for any tree-like structure def prewalking ( iterlens , predicate ) do combine ( fn recursive -&gt; predicate ~&gt; ( alongside ( [ matching ( _ ) , iterlens ~&gt; recursive ] ) ||| matching ( _ ) ) ||| ( iterlens ~&gt; recursive ) end ) end walking = postwalking ( star ( ) , matching ( %{ } ) ) # This code updates all maps and submaps in the structure %{ size : 3 , x : 1 , y : 2 , meta : %{ type : :dot , id : 1234 , size : 3 , empty_map_in_list : [ [ [ %{ size : 0 } ] ] ] } } = %{ x : 1 , y : 2 , meta : %{ type : :dot , id : 1234 , empty_map_in_list : [ [ [ %{ } ] ] ] } } |&gt; Pathex . over! ( walking , &amp; Map . put ( &amp;1 , :size , map_size ( &amp;1 ) ) )","ref":"cheatsheet.html#walk-structure","title":"Cheatsheet - Walk structure","type":"extras"},{"doc":"This guide will show you how to create powerful lenses using Pathex.Lenses module. Here we will take a look at common tasks in nested data structure manipulation which can be solved using Pathex.Lenses .","ref":"lenses.html","title":"Lenses tutorial","type":"extras"},{"doc":"What if we need to update all values in the collection matching specific pattern? This simple task can be solved using Elixir's Enum module but it is quite tough to be polymorphic and reusable for different patterns or types of collections Let's say we have a list of users with roles and we want to add access to admin page for all admins: # The list looks like this users = [ %{ fname : &quot;John&quot; , sname : &quot;Doe&quot; , role : &quot;CEO&quot; , access : [ &quot;admin_page&quot; , &quot;users_page&quot; ] } , %{ fname : &quot;Mike&quot; , sname : &quot;Lee&quot; , role : &quot;admin&quot; , access : [ &quot;users_page&quot; ] } , %{ fname : &quot;Fred&quot; , sname : &quot;Can&quot; , role : &quot;admin&quot; , access : [ &quot;users_page&quot; ] } , %{ fname : &quot;Dave&quot; , sname : &quot;Lee&quot; , role : &quot;user&quot; , access : [ ] } ] With Enum this would look like new_users = Enum . map ( users , fn %{ role : &quot;admin&quot; , access : access } = user -&gt; %{ user | access : Enum . uniq ( [ &quot;admin_page&quot; | access ] ) } other -&gt; other end ) But using Pathex.Lenses.star/0 and Pathex.Lenses.matching/1 this would look like import Pathex import Pathex.Lenses # `l` in the end stands for `lens` adminl = matching ( %{ role : &quot;admin&quot; } ) accessl = path ( :access ) # `star()` works like `*` in shell. # so `star() ~&gt; path(:file)` works almost like `*/file` # Here `star() ~&gt; adminl` translates to `select * where role == &quot;admin&quot;` # and `star() ~&gt; adminl ~&gt; accessl` translates to `select access where role == &quot;admin&quot;` new_users = Pathex . over! ( users , star ( ) ~&gt; adminl ~&gt; accessl , &amp; Enum . uniq ( [ &quot;admin_page&quot; | &amp;1 ] ) )","ref":"lenses.html#for-all-values-in-collection","title":"Lenses tutorial - For all values in collection","type":"extras"},{"doc":"What if we need to update first value matching specific pattern (in our example it will be {:option, _} ) and we need to return {:ok, updated_collection} if the first value was updated and :error if not This task can be also done using Enum , but what if we can write the solution which would be as simple as saying Update first value in collection, which matches the pattern ? With Enum this would look really terrible. I couldn't come up with a polymorphic solution that would fit in less than 20 lines of code. But with Pathex.Lenses.some/0 and Pathex.Lenses.matching/1 this would be as simple as use Pathex ; import Pathex.Lenses def update_first_option ( collection , update_func ) do Pathex . over ( collection , some ( ) ~&gt; matching ( { :option , _ } ) , update_func ) end","ref":"lenses.html#for-any-value-in-collection","title":"Lenses tutorial - For any value in collection","type":"extras"},{"doc":"Allright, we have a nested structure with various types inside and we need to find any value in any map for which the special condition occurs and change it Think of an HTML-like structure without attributes like { &quot;html&quot; , [ { &quot;head&quot; , [ ... ] } , { &quot;body&quot; , [ ... ] } ] } And we need to update just one label with string which ends with &quot;Please click subscribe button&quot; In Elixir we'd need to write a recursive function, which would untrivially update tuples and lists Using Pathex.Combinator.combine/1 , Pathex.Lenses.some/0 and Pathex.Lenses.filtering/1 it's very simple use Pathex ; import Pathex.Lenses ; import Pathex.Lenses.Recur path_to_subscribe = combine ( fn recursive -&gt; some ( ) ~&gt; ( recursive ( ) ||| matching ( ) ) end ) ~&gt; matching ( { &quot;label&quot; , _ } ) # To find a label ~&gt; path ( 1 ) # To get to value of a label ~&gt; filtering ( &amp; String . ends_with? ( &amp;1 , &quot;Please click subscribe button&quot; ) Pathex . set ( document , path_to_subscribe , &quot;Do not subscribe, hehe&quot; )","ref":"lenses.html#for-any-value-in-nested-structure","title":"Lenses tutorial - For any value in nested structure","type":"extras"},{"doc":"Sometimes you may want to create a recurring lens. We have a Pathex.Combinator.combine/1 which can help you. It is a fixed point combinator for paths, what may sound too smart, but this is a function which makes your lens be able to compose with itself. Consider this representation of an HTML { &quot;html&quot; , [ ] , [ { &quot;body&quot; , [ ] , ... } { &quot;html&quot; , [ ] , ... } ] } And we want to update a node which has id=big-image . It would be nice to have a lens which would do something like path ( 2 ) ~&gt; some ( ) ~&gt; path ( 2 ) ~&gt; some ( ) ~&gt; path ( 2 ) ~&gt; some ( ) ` Until it finds the tag we're looking for. Meet the Pathex.Combinator.combine/1 . Using this higher order function we can represent lens combining with itself. The lens above can be specified with this code. combine ( fn recursive -&gt; path ( 2 ) ~&gt; some ( ) ~&gt; recursive end ) And we also need to find a specific id, so let's combine this lens with matching(_) path_to_id = combine ( fn recursive -&gt; path ( 2 ) ~&gt; some ~&gt; recursive end ) ~&gt; matching ( { _ , [ { &quot;id&quot; , &quot;big-image&quot; } ] , _ } ) However, it has a drawback -- this recursive lens will never succeed, because we didn't specify the exit. Let's fix it path_to_big_image = combine ( fn recursive -&gt; path ( 2 ) ~&gt; some ~&gt; ( recursive ||| matching ( _ ) ) end ) ~&gt; matching ( { _ , [ { &quot;id&quot; , &quot;big-image&quot; } ] , _ } ) { &quot;div&quot; , [ { &quot;id&quot; , &quot;big-image&quot; } ] , [ { &quot;img&quot; , [ { &quot;src&quot; , &quot;/image.png&quot; } ] , &quot;&quot; } ] } = Pathex . view! ( html , path_to_big_image )","ref":"lenses.html#recurring","title":"Lenses tutorial - Recurring","type":"extras"},{"doc":"Every pathex path created with Pathex.path/2 can have modifier specified as a second argument. Modifier defines behaviour of the path in a way of structures it can match inside. For example, path created with :map modifier can only match maps inside them. Modifiers can be specified only in form of an atom, variables are not accepted.","ref":"modifiers.html","title":"Modifiers tutorial","type":"extras"},{"doc":"Currently only three modifiers are available: :json which matches lists and maps :naive which matches lists, tuples, keywords and maps :map which matches only maps Default modifier for every path is :naive Modifiers are specified as second argument in path/2 like path :x / :y , :naive path 0 / :x , :json","ref":"modifiers.html#usage","title":"Modifiers tutorial - Usage","type":"extras"},{"doc":"This modifier matches lists, tuples, keyword and maps It generates matches for every structure like For example path(:x, :naive) generates something like case input do %{ x : value } -&gt; ... [ { a , _ } | _ ] = k when is_atom ( a ) -&gt; case Keyword . fetch ( k , :x ) do ... end end Note: Variables are treated as their values","ref":"modifiers.html#naive-modifier","title":"Modifiers tutorial - Naive modifier","type":"extras"},{"doc":"This modifier specifies paths which macth lists (for integer keys only) and maps Note: This modifier treats variables as map keys, this means that iex&gt; x = 1 iex&gt; p = path x , :json iex&gt; :error = Pathex . view ( [ 1 , 2 , 3 ] , p ) iex&gt; { :ok , :x } = Pathex . view ( %{ 1 =&gt; :x } , p ) But passed integers are exanded into list matching this makes it very efficient to view data from the structure For example path 1 / :x, :json generates closure with case input do [ _ , %{ x : value } | _ ] -&gt; { :ok , value } %{ 1 =&gt; %{ x : value } } -&gt; { :ok , value } _ -&gt; :error end Which extracts maximum efficiency from BEAM's pattern-matching","ref":"modifiers.html#json-modifier","title":"Modifiers tutorial - Json modifier","type":"extras"},{"doc":"This modifier matches only maps and therefore is the fastest modifier available For example path 1 / :x / &quot;y&quot;, :map will generate closure with case input do %{ 1 =&gt; %{ x : %{ &quot;y&quot; =&gt; value } } } -&gt; { :ok , value } _ -&gt; :error end","ref":"modifiers.html#map-modifier","title":"Modifiers tutorial - Map modifier","type":"extras"},{"doc":"Usually a key passed to path can match to one or more types. For example, key :x can be a key in Map like %{x: 1} and a key in Keyword like [x: 1] . To make key match only certain type it can be annotated to the exact type using this syntax path(:x :: :map) . Available annotations are :map , :keyword , :list and :tuple .","ref":"modifiers.html#annotations","title":"Modifiers tutorial - Annotations","type":"extras"},{"doc":"You should use modifiers when you need to specify type of inner structures to match or reduce amount of generated code by Pathex or improve performance of the path","ref":"modifiers.html#when-how-why","title":"Modifiers tutorial - When? How? &amp; Why?","type":"extras"},{"doc":"Note: This is a documentation about internal Pathex API and it is subject to change You do not need to read this unless you are interested in Pathex internals, want to hack Pathex or want to create your own Pathex compatible lens This page describes what a Pathex.t() is and how to create and use one. Most of the time you might want to use Pathex.path/2 and Pathex.Lenses to create paths. If you find their functionality limited and unapplicable for your use case, you can create you own Pathex-compatible closure. This doc describes how to do this.","ref":"path.html","title":"Path","type":"extras"},{"doc":"Path-closure is specified in Pathex.t() , and it's a closure of two arguments: Operation name. It is an atom, one of :view , :update , :force_update , :delete , :inpsect Operation arguments. It is a tuple which size depends on an operation Currently every path-closure has 5 operations: path_closure = fn # Operation which gets value from structure and return `function.(value)` :view , { structure , hook_function } -&gt; ... # Operation which returns new structure with updated value :update , { structure , hook_function } -&gt; ... # Operation which returns new structure with updated value, or default set :force_update , { structure , hook_function , default } -&gt; ... # Operation which returns new structure with deleted value. :delete , { structure , delete_function } -&gt; ... # Inspects the path. Returns Elixir&#39;s AST. This is used only for error-logging and debugging :inspect , _ -&gt; ... end Here structure is the structure which is viewed or updated by this path and hook_function or delete_function is a hook function described in the next section. If the value in the structure defined by the path is not present, path-closure must return :error . If it's present, path-closure must return whatever is returned by hook_function(value)","ref":"path.html#path-closure","title":"Path - Path-closure","type":"extras"},{"doc":"You can see that for every operation except inspect accepts some function as a second argument. This function is called a hook function and it must be called on the value from the structure defined by the path (if the value is present). Hook function is required to Return types Here function returns {:ok, result} | :error And delete_function returns {:ok, result} | :error | :delete_me {:ok, result} returns updated value for update/force_update/delete operations and value to be returned for view :error in case function call has not succeeded :delete_me is returned by function only for :delete operation clause. It means that the value upon which the hook function was called must be deleted. For all other clauses, this must be treated as an invalid hook function and error must be raised","ref":"path.html#hook-function","title":"Path - Hook function","type":"extras"},{"doc":"Special requirements are described here Path-closure must not raise or throw if it's called with correct operation and argument tuple Path-closure must be idempotent. This means that path-closure must return the same result for the same inputs every time it's called. Path-closure should not produce any side-effects. Thought it actually can produce side-effects, you shouldn't count on them.","ref":"path.html#qualities","title":"Path - Qualities","type":"extras"}]